<#--
 # MCreator (https://mcreator.net/)
 # Copyright (C) 2012-2020, Pylo
 # Copyright (C) 2020-2023, Pylo, opensource contributors
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation, either version 3 of the License, or
 # (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <https://www.gnu.org/licenses/>.
 #
 # Additional permission for code generator templates (*.ftl files)
 #
 # As a special exception, you may create a larger work that contains part or
 # all of the MCreator code generator templates (*.ftl files) and distribute
 # that work under terms of your choice, so long as that work isn't itself a
 # template for code generation. Alternatively, if you modify or redistribute
 # the template itself, you may (at your option) remove this special exception,
 # which will cause the template and the resulting code generator output files
 # to be licensed under the GNU General Public License without this special
 # exception.
-->

<#-- @formatter:off -->
<#include "../procedures.java.ftl">

package ${package}.network;

@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD) public class ${name}ButtonMessage {

	private final int buttonID, x, y, z;
	private HashMap<String, String> textstate;

	public ${name}ButtonMessage(FriendlyByteBuf buffer) {
		this.buttonID = buffer.readInt();
		this.x = buffer.readInt();
		this.y = buffer.readInt();
		this.z = buffer.readInt();
		this.textstate = readTextState(buffer);
	}

	public ${name}ButtonMessage(int buttonID, int x, int y, int z, HashMap<String, String> textstate) {
		this.buttonID = buttonID;
		this.x = x;
		this.y = y;
		this.z = z;
		this.textstate = textstate;
		
	}

	public static void buffer(${name}ButtonMessage message, FriendlyByteBuf buffer) {
		buffer.writeInt(message.buttonID);
		buffer.writeInt(message.x);
		buffer.writeInt(message.y);
		buffer.writeInt(message.z);
		writeTextState(message.textstate, buffer);
	}

	public static void handler(${name}ButtonMessage message, Supplier<NetworkEvent.Context> contextSupplier) {
		NetworkEvent.Context context = contextSupplier.get();
		context.enqueueWork(() -> {
			Player entity = context.getSender();
			int buttonID = message.buttonID;
			int x = message.x;
			int y = message.y;
			int z = message.z;
			HashMap<String, String> textstate = message.textstate;

			handleButtonAction(entity, buttonID, x, y, z, textstate);
		});
		context.setPacketHandled(true);
	}

	public static void handleButtonAction(Player entity, int buttonID, int x, int y, int z, HashMap<String, String> textstate) {
		Level world = entity.level();
		HashMap guistate = ${name}Menu.guistate;
		for (Map.Entry<String, String> entry : textstate.entrySet()) {
        String key = entry.getKey();
        String value = entry.getValue();
        guistate.put(key, value); 
}

		// security measure to prevent arbitrary chunk generation
		if (!world.hasChunkAt(new BlockPos(x, y, z)))
			return;

		<#assign btid = 0>
		<#list data.getComponentsOfType("Button") as component>
				<#if hasProcedure(component.onClick)>
					if (buttonID == ${btid}) {
						<@procedureOBJToCode component.onClick/>
					}
				</#if>
				<#assign btid +=1>
		</#list>
		<#list data.getComponentsOfType("ImageButton") as component>
				<#if hasProcedure(component.onClick)>
					if (buttonID == ${btid}) {
						<@procedureOBJToCode component.onClick/>
					}
				</#if>
				<#assign btid +=1>
		</#list>
	}

	@SubscribeEvent public static void registerMessage(FMLCommonSetupEvent event) {
		${JavaModName}.addNetworkMessage(${name}ButtonMessage.class, ${name}ButtonMessage::buffer, ${name}ButtonMessage::new, ${name}ButtonMessage::handler);
	}
	
	public static void writeTextState(HashMap<String, String> map, FriendlyByteBuf buffer) {
    buffer.writeInt(map.size()); 
    for (Map.Entry<String, String> entry : map.entrySet()) {
        buffer.writeComponent(Component.literal(entry.getKey()));  
        buffer.writeComponent(Component.literal(entry.getValue())); 
    }
}

    public static HashMap<String, String> readTextState(FriendlyByteBuf buffer) {
    int size = buffer.readInt(); 
    HashMap<String, String> map = new HashMap<>();
    for (int i = 0; i < size; i++) {
        String key = buffer.readComponent().getString();
        String value = buffer.readComponent().getString();
        map.put(key, value);
    }
    return map;
    }

}
<#-- @formatter:on -->